<?php
/**
 * PHPUnit test case for App
 *
 * The method skeletons below need to be filled in with
 * real data so that the tests will run correctly. Replace
 * all EXPECTED_VAL and PARAM strings with real data.
 *
 * Created with PHPUnit_Skeleton on 2005-08-09
 */
require_once 'PHPUnit.php';
class AppTest extends PHPUnit_TestCase {

    var $App;

    function AppTest($name)
    {
        $this->PHPUnit_TestCase($name);
    }

    function setUp()
    {
        require dirname(__FILE__) . '/_config.inc.php';
        $this->App =& $app;
    }

    function tearDown()
    {
        unset($this->App);
    }

    function test_getinstance()
    {
        $thisapp =& App::getInstance();
        $this->assertTrue(serialize($thisapp) == serialize($this->App), 'Objects do not match across instantiations.');
    }

    function test_setParam()
    {
        $this->App->setParam(array(
            'test_config_value' => 1234
        ));
        $this->assertTrue(1234 === $this->App->_params['test_config_value']);
    }

    function test_getParam()
    {
        $this->App->_params['test_config_value2'] = 'okay';
        $result = $this->App->getParam('test_config_value2');
        $this->assertEquals('okay', $result);
    }

    function test_start()
    {
        unset($_SESSION);
        $this->App->stop();
        $this->App->start();

        $this->assertEquals(ini_get('error_reporting'), E_ALL, 'Error reporting not set to E_ALL.');
        $this->assertTrue($this->App->db->dbh && is_resource($this->App->db->dbh), 'DB handler not a resource');
        $this->assertTrue(isset($_SESSION), '$_SESSION is not set.');
        $_SESSION['sess_test_value'] = 'okay';
        $this->assertEquals($_SESSION['sess_test_value'], 'okay', '$_SESSION not storing values.');
        $this->assertTrue(session_name() == 'StrangecodeTestSession', 'Session_name not set correctly.');
    }

    function test_stop()
    {
    }

    function test_dbquery()
    {
		$db =& DB::getInstance();
	
        $qid = $db->query("SELECT 2 + 2");
        list($result) = mysql_fetch_row($qid);
        $this->assertEquals('4', $result);
    }

    function test_raisemsg()
    {
        $app =& App::getInstance();
        $expected = 'My message';
        $app->raiseMsg($expected, MSG_NOTICE, __FILE__, __LINE__);
        $msg = current($_SESSION[$this->App->_ns]['messages']);
        $this->assertEquals($expected, $msg['message']);
    }

    function test_printraisedmessages()
    {
        ob_start();
        $app =& App::getInstance();
        $app->printraisedmessages();
        $result = ob_get_clean();
        $this->assertContains('My message', $result, 'Raised message not found in output.');
    }

    function test_logmsg()
    {
        $app =& App::getInstance();
        $file = $this->App->getParam('log_directory') . '/' . $this->App->getParam('log_filename');
        $app->logMsg('Test log message', LOG_DEBUG, __FILE__, __LINE__);
        if ($result = file($file)) {
            $result = end($result);
        } else {
            $result = '';
        }
        $this->assertContains('Test log message', $result, 'Test message not recorded in log: ' . $file);
    }

    function test_ohref()
    {
        $app =& App::getInstance();
        $_GET['arg1'] = 'A';
        $result = $app->ohref('/some/url.php', array('arg1'), true);
        $this->assertContains(session_name(), $result, 'SSID not found in URL.');
        $this->assertContains('arg1=A', $result, 'Argument not passed through.');
    }

    function test_printhiddensession()
    {
        $app =& App::getInstance();
        ob_start();
        $app->printhiddensession();
        $result = ob_get_clean();
        $this->assertContains(session_name(), $result);
    }

//     function test_dieurl()
//     {
//         $app =& App::getInstance();
//         $app->dieURL('/die/to/this/url.php');
//     }
//
//     function test_dieboomerangurl()
//     {
//         $result = $this->App->dieboomerangurl(PARAM);
//         $expected = EXPECTED_VAL;
//         $this->assertEquals($expected, $result);
//     }
//
//     function test_setboomerangurl()
//     {
//         $result = $this->App->setboomerangurl(PARAM);
//         $expected = EXPECTED_VAL;
//         $this->assertEquals($expected, $result);
//     }
//
//     function test_getboomerangurl()
//     {
//         $result = $this->App->getboomerangurl(PARAM);
//         $expected = EXPECTED_VAL;
//         $this->assertEquals($expected, $result);
//     }
//
//     function test_deleteboomerangurl()
//     {
//         $result = $this->App->deleteboomerangurl(PARAM);
//         $expected = EXPECTED_VAL;
//         $this->assertEquals($expected, $result);
//     }
//
//     function test_validboomerangurl()
//     {
//         $result = $this->App->validboomerangurl(PARAM);
//         $expected = EXPECTED_VAL;
//         $this->assertEquals($expected, $result);
//     }
//
//     function test_sslon()
//     {
//         $result = $this->App->sslon(PARAM);
//         $expected = EXPECTED_VAL;
//         $this->assertEquals($expected, $result);
//     }
//
//     function test_ssloff()
//     {
//         $result = $this->App->ssloff(PARAM);
//         $expected = EXPECTED_VAL;
//         $this->assertEquals($expected, $result);
//     }

}
// Running the test.
$suite = new PHPUnit_TestSuite('AppTest');
$result = PHPUnit::run($suite);
echo $result->toString();
?>
